dp-leetcode152
动态规划问题,存在重叠子问题
/**
* <p>给你一个整数数组 <code>nums</code> ,请你找出数组中乘积最大的非空连续子数组(该子数组中至少包含一个数字),并返回该子数组所对应的乘积。</p>
*
* <p>测试用例的答案是一个 <strong>32-位</strong> 整数。</p>
*
* <p><strong>子数组</strong> 是数组的连续子序列。</p>
*
* <p> </p>
*
* <p><strong>示例 1:</strong></p>
*
* <pre>
* <strong>输入:</strong> nums = [2,3,-2,4]
* <strong>输出:</strong> <code>6</code>
* <strong>解释:</strong> 子数组 [2,3] 有最大乘积 6。
* </pre>
*
* <p><strong>示例 2:</strong></p>
*
* <pre>
* <strong>输入:</strong> nums = [-2,0,-1]
* <strong>输出:</strong> 0
* <strong>解释:</strong> 结果不能为 2, 因为 [-2,-1] 不是子数组。</pre>
*
* <p> </p>
*
* <p><strong>提示:</strong></p>
*
* <ul>
* <li><code>1 <= nums.length <= 2 * 10<sup>4</sup></code></li>
* <li><code>-10 <= nums[i] <= 10</code></li>
* <li><code>nums</code> 的任何前缀或后缀的乘积都 <strong>保证</strong> 是一个 <strong>32-位</strong> 整数</li>
* </ul>
* <div><div>Related Topics</div><div><li>数组</li><li>动态规划</li></div></div><br><div><li>👍 1838</li><li>👎 0</li></div>
*/
//leetcode submit region begin(Prohibit modification and deletion)
class Solution {
public int maxProduct(int[] nums) {
if (nums.length == 0) {
return 0;
}
int n = nums.length;
int[] dpMax = new int[n + 1];
int[] dpMin = new int[n + 1];
dpMax[0] = nums[0];
dpMin[0] = nums[0];
int res = dpMax[0];
for (int i = 1; i < n; i++) {
// 考虑情况 5,6,-3,4,-3 这个情况,所以递推方程要考虑 负数,也就是最小值问题
dpMax[i] = Math.max(dpMax[i - 1] * nums[i], Math.max(dpMin[i - 1] * nums[i], nums[i]));
dpMin[i] = Math.min(dpMax[i - 1] * nums[i], Math.min(dpMin[i - 1] * nums[i], nums[i]));
res = Math.max(dpMax[i], res);
}
return res;
}
}
//leetcode submit region end(Prohibit modification and deletion)
不恋尘世浮华,不写红尘纷扰